import os


def PCAPlot2tikz(reduced, adjectives, filename):
    """
    writes a txt file formated so that it can be used to generate a tikz image in LaTeX

    Parameters
    ----------
    reduced : vectors in matrix form, after PCA
    adjectives : dictionary with entries "word: trait"
    filename : str, filename to export data
    """
    if not os.path.isdir('./results_export'):
        os.makedirs('./results_export')

    dims = len(reduced[0])
    xmin = min(reduced.T[0])
    xmax = max(reduced.T[0])
    ymin = min(reduced.T[1])
    ymax = max(reduced.T[1])
    dx = abs(xmax-xmin)
    dy = abs(ymax-ymin)

    styles = {'extraversion': 'wbhblue', 'agreeableness': 'wbhpurple', 'conscientiousness': 'wbhgreen', 'neuroticism': 'wbhdarkpurple', 'open-mindedness': 'wbhred'}
    axis_style = {'xmin': xmin-0.05*dx,\
                  'xmax': xmax+0.05*dx,\
                  'ymin': ymin-0.05*dy,\
                  'ymax': ymax+0.05*dy,\
                  'width': '\\textwidth',\
                  'clip': 'false',\
                  'legend style': '{font=\\tiny, anchor=north east, at={(1,1)}}',\
                  'legend cell align': 'left'}

    if dims >= 3:
        zmin = min(reduced.T[2])
        zmax = max(reduced.T[2])
        dz = abs(zmax-zmin)
        axis_style['height'] = '0.8\\textwidth'
        axis_style['zmin'] = zmin-0.05*dz
        axis_style['zmax'] = zmax+0.05*dz
        axis_style['view'] = '{80}{40}'
    else:
        axis_style['height'] = '0.618\\textwidth'

    with open('./results_export/'+str(filename), 'w') as file_out:
        file_out.write('\\begin{axis}[\n')
        for option, value in axis_style.items():
            file_out.write('\t'+str(option)+'='+str(value)+',\n')
        file_out.write(']\n')
        for m, word in enumerate(adjectives.keys()):
            if dims >= 3:
                file_out.write('\t\\draw[densely dashed, '+styles[adjectives[word]]+'] ('+str(reduced[m][0])+','+str(reduced[m][1])+','+str(reduced[m][2]-0.025)+') -- ('+str(reduced[m][0])+','+str(reduced[m][1])+','+str(zmin)+') node[cross out , inner sep=0pt, minimum size=1pt, draw] {};\n')
        for m, word in enumerate(adjectives.keys()):
            if dims == 2:
                file_out.write('\t\\node['+styles[adjectives[word]]+', font=\\tiny\\bfseries] at ('+str(reduced[m][0])+','+str(reduced[m][1])+') {'+word+'};\n')
            else:
                file_out.write('\t\\node['+styles[adjectives[word]]+', font=\\tiny\\bfseries] at ('+str(reduced[m][0])+','+str(reduced[m][1])+','+str(reduced[m][2])+') {'+word+'};\n')
        for entry, color in styles.items():
            file_out.write('\t\\addlegendimage{only marks, mark=square*, '+color+'}\n')
            file_out.write('\t\\addlegendentry{'+entry+'}\n')
        file_out.write('\\end{axis}')


def clusters2tikz(labels, labels_true, adjectives, filename):
    """
    writes a txt file formated so that it can be used to generate a tikz image in LaTeX

    Parameters
    ----------
    labels : list with labels generated by clustering algorithm
    labels_true : list with true labels
    adjectives : dictionary with entries "word: trait"
    filename : Tstr, filename to export data
    """
    if not os.path.isdir('./results_export'):
        os.makedirs('./results_export')

    styles = {'extraversion': 'wbhblue', 'agreeableness': 'wbhpurple', 'conscientiousness': 'wbhgreen', 'neuroticism': 'wbhdarkpurple', 'open-mindedness': 'wbhred'}

    labels_dict= dict()
    for m, adj in enumerate(adjectives.keys()):
        if adj in ['original', 'nervous', 'affectionate', 'outgoing', 'efficient']:
            labels_dict[labels[m]] = labels_true[m]

    with open('./results_export/'+str(filename), 'w') as file_out:
        label_counter = [0,0,0,0,0]
        label_true_counter = [0,0,0,0,0]
        for m, adj in enumerate(adjectives.keys()):
            label = labels_dict[labels[m]]
            current_node = str(label)+'_'+str(label_counter[label])
            node_style = 'rectangle, thick, anchor=south, minimum width=7.5em, draw='+str(styles[adjectives[adj]])+', fill='+str(styles[adjectives[adj]])+'!20'
            if label_counter[label] == 0:
                previous_node = str(label*3)+',0'
            else:
                previous_node = str(label)+'_'+str(label_counter[label]-1)+'.north'
            file_out.write('\\node['+node_style+'] ('+current_node+') at ('+previous_node+') {'+str(adj)+'\\vphantom{gI}}; \n')
            label_counter[label] += 1
            label_true_counter[labels_true[m]] += 1
        for m, (trait, color) in enumerate(styles.items()):
            file_out.write('\\node ('+str(trait)+') at ('+str(m*3)+',-0.75) {'+str(trait)+'};\n')
            file_out.write('\\node[rectangle, thick, minimum height=0.75em, minimum width=1.5em, inner sep=0pt, anchor=north, draw='+str(color)+', fill='+str(color)+'!20] at ('+str(trait)+'.south) {};\n')

    print(label_counter)


def vectorsPOLAR2tikz(categories, avgs_normalized, SD_dict, filename, draw_which='positive'):
    if not os.path.isdir('./results_export'):
        os.makedirs('./results_export')
    pn_dict = {'positive': '+', 'negative': '-'}
    styles = {'extraversion': 'wbhblue', 'agreeableness': 'wbhpurple', 'conscientiousness': 'wbhgreen', 'neuroticism': 'wbhdarkpurple', 'open-mindedness': 'wbhred'}

    with open('./results_export/'+str(filename), 'w') as file_out:
        file_out.write('\\def\\fac {3}\n')
        file_out.write('\\def\\hdist {0.7}\n')
        file_out.write('\\def\\jit {0.09}\n')
        for k, tr in enumerate(categories):
            file_out.write('\\node[rectangle, draw, thick, minimum width=1.75em, anchor=west, '+styles[tr]+'] (T'+str(k)+'+) at (2,-\\hdist*'+str(k)+') {'+str(tr)[0].upper()+'\\raise.30ex\\hbox{\\tiny +}};\n')
            file_out.write('\\node[rectangle, draw, thick, minimum width=1.75em, anchor=east, '+styles[tr]+'] (T'+str(k)+'-) at (-2,-\\hdist*'+str(k)+') {'+str(tr)[0].upper()+'\\raise.30ex\\hbox{\\tiny --}};\n')
            file_out.write('\\draw[gray!50, thick] (T'+str(k)+'-) -- (T'+str(k)+'+);\n')
        file_out.write('\\draw[gray!50, thick] (0,0) -- (0,-4*\\hdist) node[label={270:$0$}] {};\n')
        file_out.write('\\draw[densely dashed, gray!50, thick] (0.4*\\fac,0) -- (0.4*\\fac,-4*\\hdist) node[label={270:$0.4$}] {};\n')
        file_out.write('\\draw[densely dashed, gray!50, thick] (-0.4*\\fac,0) -- (-0.4*\\fac,-4*\\hdist) node[label={270:$-0.4$}] {};\n')
        for n, (trait, pn_d) in enumerate(SD_dict.items()):
            for pn, SD in pn_d.items():
                if pn == draw_which:
                    for k, sd in enumerate(SD):
                        avg_loc = avgs_normalized[trait][pn][k]
                        file_out.write('\draw[ultra thick, '+styles[trait]+'] (0,-'+str(k)+'*\\hdist-'+str(n-2)+'*\\jit) -- ++(-\\fac*'+str(sd)+',0) -- +(0,0) -- +(0,-0);\n')
                        # file_out.write('\draw[thick, '+styles[trait]+'] (\\fac*'+str(avg_loc)+',-'+str(k)+'*\\hdist) -- ++(0,'+str(n-2)+'*\\jit) -- ++(-\\fac*'+str(sd)+',0) -- +(0,0.1) -- +(0,-0.1);\n')
        for trait, pn_d in avgs_normalized.items():
            for pn, avg in pn_d.items():
                if pn == draw_which:
                    file_out.write('\\draw[thick, '+styles[trait]+'] (\\fac*'+str(avg[0])+',0) node[circle, draw, inner sep=1.5pt] {} -- (\\fac*'+str(avg[1])+',-\\hdist) node[circle, draw, inner sep=1.5pt] {} -- (\\fac*'+str(avg[2])+',-2*\\hdist) node[circle, draw, inner sep=1.5pt] {} -- (\\fac*'+str(avg[3])+',-3*\\hdist) node[circle, draw, inner sep=1.5pt] {} -- (\\fac*'+str(avg[4])+',-4*\\hdist) node[circle, draw, inner sep=1.5pt] {};\n')